'use strict';

//SCHEMAcat module definition
var SCHEMAcat = angular.module('SCHEMAcat', ['ui.bootstrap', 'ngRoute', 'ngResource', 'tlaGenerics']);

SCHEMAcat.config(['$routeProvider',
    function($routeProvider) {
        var loadDelay = 250; //ms
        $routeProvider
            .when('/workspace.html/page/:pageNumber/', {
                controller: 'WorkspaceCtrl',
                templateUrl: 'partials/workspace.html',

                /* 
                With this, the $routeProvider will trigger $routeChangeSuccess 
                event if the path part (//workspace/page/:pageNumber/) is not the 
                same as current location, causing angular to reload the controller
                (flickering the view).
                Otherwise it will trigger $routeUpdate event which does not reload
                the controller neither updates the view. We have to listen to this
                event if we need to update the view when the search part of the 
                route changes.
                */
                reloadOnSearch: false,
                resolve: {
                    //this will cause a 0.25 second delay to allow CSS fadeOut animation to 
                    //be displayed
                    delay: ['$q', '$timeout', 'Settings',
                        function($q, $timeout, Settings) {
                            if (Settings.getAnimationStatus()) {
                                var delay = $q.defer();
                                $timeout(delay.resolve, loadDelay);
                                return delay.promise;
                            } else
                                return;
                        }
                    ]
                }
            })
            .when('/about.html', {
                controller: 'AboutPageCtrl',
                templateUrl: 'partials/about.html',
                reloadOnSearch: false,
                resolve: {
                    delay: ['$q', '$timeout', 'Settings',
                        function($q, $timeout, Settings) {
                            if (Settings.getAnimationStatus()) {
                                var delay = $q.defer();
                                $timeout(delay.resolve, loadDelay);
                                return delay.promise;
                            } else
                                return;
                        }
                    ]
                }
            })
            .when('/contact.html', {
                controller: 'ContactPageCtrl',
                templateUrl: 'partials/contact.html',
                reloadOnSearch: false,
                resolve: {
                    delay: ['$q', '$timeout', 'Settings',
                        function($q, $timeout, Settings) {
                            if (Settings.getAnimationStatus()) {
                                var delay = $q.defer();
                                $timeout(delay.resolve, loadDelay);
                                return delay.promise;
                            } else
                                return;
                        }
                    ]
                }
            })
            .when('/accountDetails.html', {
                controller: 'AccountDetailsPageCtrl',
                templateUrl: 'partials/accountDetails.html',
                reloadOnSearch: false,
                resolve: {
                    delay: ['$q', '$timeout', 'Settings',
                        function($q, $timeout, Settings) {
                            if (Settings.getAnimationStatus()) {
                                var delay = $q.defer();
                                $timeout(delay.resolve, loadDelay);
                                return delay.promise;
                            } else
                                return;
                        }
                    ]
                }
            })
            .otherwise({
                redirectTo: function(routeParams, path, search) {
                    return '/workspace.html/page/1/?schemaIndex=0';
                }
            });
    }
]);