'use strict';
//SCHEMAcat angular services
SCHEMAcat.factory('SchemasList', ['$resource',
    function($resource) {
        var schemasList = $resource('/schemacat/users/:userID/schemas/pagedlist/page/:startPage/pagesize/:pageSize', {
            userID: 'guest'
        });
        return schemasList;
    }
]);

SCHEMAcat.factory('Schema', ['$resource',
    function($resource) {
        var schema = $resource('/schemacat/schemas/:schemaID/:schemaField', {
            schemaID: '',
            schemaField: ''
        });
        return schema;
    }
]);

SCHEMAcat.factory('User', ['$resource',
    function($resource) {
        var user = $resource('/schemacat/users/:userID', {
            userID: ''
        });
        return user;
    }
]);

SCHEMAcat.factory('Licenses', ['$resource',
    function($resource) {
        var licenses = $resource('/schemacat/licenses');
        return licenses;
    }
]);

SCHEMAcat.factory('Settings', ['$resource',
    function() {
        var animations = true;
        var objectStore = {};

        function _setAnimationStatus(value) {
            animations = value;
        }

        function _getAnimationStatus() {
            return animations;
        }

        function _getStore() {
            return objectStore;
        }

        return {
            getAnimationStatus: _getAnimationStatus,
            setAnimationStatus: _setAnimationStatus,
            getStore: _getStore
        };
    }
]);